Subject: bug#17165: closed (Re: bug#17165: 24.4.50; icomplete-exhibit: (wrong-type-argument number-or-marker-p nil))

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 07 Dec 2016 20:00:03 +0000

Your bug report

#17165: 24.4.50; icomplete-exhibit: (wrong-type-argument number-or-marker-p nil)

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
17165: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=17165
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#17165: 24.4.50; icomplete-exhibit: (wrong-type-argument number-or-marker-p nil)
From: Glenn Morris <[email-masked]>
To: [email-masked]
Date: Wed, 07 Dec 2016 14:58:56 -0500
List-Id: <debbugs-submit.debbugs.gnu.org>

>> Do you have a recipe for this bug?
>
> No.  And I haven't been able to debug it.

So it can't lead anywhere; closing.

Subject: 24.4.50; icomplete-exhibit: (wrong-type-argument number-or-marker-p nil)
From: Drew Adams <[email-masked]>
To: [email-masked]
Date: Tue, 1 Apr 2014 18:59:18 -0700 (PDT)
List-Id: <debbugs-submit.debbugs.gnu.org>

I have some code that does this:

(when (and (featurep 'icomplete)
           (natnump icicle-icomplete-mode-max-candidates))
      (if (< nb-cands icicle-icomplete-mode-max-candidates)
          (if (not icicle-last-icomplete-mode-value)
              (icomplete-mode -1)
            (icomplete-mode 1)
            (icomplete-exhibit)) ; <==========
          (icomplete-tidy)
          (icomplete-mode -1)))

Once in a while I have seen this wrong-type-argument error.  I suspect,
but I do not know, that it comes from this code in `icomplete-exhibit':

(if (and (or icomplete-show-matches-on-no-input
             (> (icomplete--field-end) (icomplete--field-beg)))
    ...

I see that `icomplete--field-end' and `icomplete--field-beg' are defined
simply in terms of `completion-in-region--data'.  And AFAICT, that
variable can be nil, in which case each of `icomplete--field-(end|beg)'
is nil also.

I see too that in minibuffer.el `completion-in-region--data' is
initialized to nil, and the code there takes care to test for a non-nil
value before trying to access its components using `nth':

(and completion-in-region--data
     (and (eq (marker-buffer (nth 0 completion-in-region--data))
              (current-buffer))
          (>= (point) (nth 0 completion-in-region--data))
          (<= (point)
              (save-excursion
                (goto-char (nth 1 completion-in-region--data))
                (line-end-position)))
         (funcall completion-in-region-mode--predicate)))

A naive guess is that the code in icomplete.el should do likewise:
ensure that `completion-in-region--data' is non-nil before applying
`nth' to it and then using the result in a numeric comparison.

HTH.

In GNU Emacs 24.4.50.1 (i686-pc-mingw32)
 of 2014-03-27 on ODIEONE
Bzr revision: 116884 [email-masked]
Windowing system distributor `Microsoft Corp.', version 6.1.7601
Configured using:
 `configure --prefix=/c/Devel/emacs/snapshot/trunk
 --enable-checking=yes,glyphs 'CFLAGS=-O0 -g3'
 LDFLAGS=-Lc:/Devel/emacs/lib 'CPPFLAGS=-DGC_MCHECK=1
 -Ic:/Devel/emacs/include''